<?php
class ModelCatalogForum extends Model {
    public function updateViewed($forum_id) {
		$this->db->query("UPDATE " . DB_PREFIX . "forum SET viewed = (viewed + 1) WHERE forum_id = '" . (int)$forum_id . "'");
	}
	
    public function addRevcat($category_id, $data) {
		$this->db->query("INSERT INTO " . DB_PREFIX . "forum_review SET name = '" . $this->db->escape($data['name']) . "', customer_id = '" . (int)$this->customer->getId() . "', text = '" . $this->db->escape($data['text']) . "', text_id = '" . (int)$category_id . "', date_added = NOW()");

		$review_id = $this->db->getLastId();
                if ($this->config->get('config_review_mail')) {
			$this->load->language('mail/forum');
			
			
			$product_info = $this->getForum($category_id);

			$subject = sprintf($this->language->get('text_subject'), html_entity_decode($this->config->get('config_name'), ENT_QUOTES, 'UTF-8'));

			$message  = $this->language->get('text_waiting') . "\n";
			$message .= sprintf($this->language->get('text_product'), html_entity_decode($product_info['name'], ENT_QUOTES, 'UTF-8')) . "\n";
			$message .= sprintf($this->language->get('text_reviewer'), html_entity_decode($data['name'], ENT_QUOTES, 'UTF-8')) . "\n";
			
			$message .= $this->language->get('text_review') . "\n";
			$message .= html_entity_decode($data['text'], ENT_QUOTES, 'UTF-8') . "\n\n";

			$mail = new Mail();
			$mail->protocol = $this->config->get('config_mail_protocol');
			$mail->parameter = $this->config->get('config_mail_parameter');
			$mail->smtp_hostname = $this->config->get('config_mail_smtp_hostname');
			$mail->smtp_username = $this->config->get('config_mail_smtp_username');
			$mail->smtp_password = html_entity_decode($this->config->get('config_mail_smtp_password'), ENT_QUOTES, 'UTF-8');
			$mail->smtp_port = $this->config->get('config_mail_smtp_port');
			$mail->smtp_timeout = $this->config->get('config_mail_smtp_timeout');

			$mail->setTo($this->config->get('config_email'));
			$mail->setFrom($this->config->get('config_email'));
			$mail->setSender(html_entity_decode($this->config->get('config_name'), ENT_QUOTES, 'UTF-8'));
			$mail->setSubject($subject);
			$mail->setText($message);
			$mail->send();

			// Send to additional alert emails
			$emails = explode(',', $this->config->get('config_mail_alert'));

			foreach ($emails as $email) {
				if ($email && preg_match($this->config->get('config_mail_regexp'), $email)) {
					$mail->setTo($email);
					$mail->send();
				}
			}
		}
		
	}
	public function getForums($parent_id = 0, $start = 0, $limit = 20) {
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "forum c LEFT JOIN " . DB_PREFIX . "forum_description cd ON (c.forum_id = cd.forum_id) WHERE c.parent_id = '" . (int)$parent_id . "' AND  cd.language_id = '" . (int)$this->config->get('config_language_id') . "' AND c.status = '1' ORDER BY c.sort_order  LIMIT " . (int)$start . "," . (int)$limit);

		return $query->rows;
	}
	
	public function getTotalForums($parent_id = 0) {
	    $query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "forum  WHERE parent_id = '" . (int)$parent_id . "'");

		return $query->row['total'];
	}

    public function getForum($forum_id) {
		$query = $this->db->query("SELECT DISTINCT * FROM " . DB_PREFIX . "forum c LEFT JOIN " . DB_PREFIX . "forum_description cd ON (c.forum_id = cd.forum_id)  WHERE c.forum_id = '" . (int)$forum_id . "' AND cd.language_id = '" . (int)$this->config->get('config_language_id') . "' AND c.status = '1'");

		return $query->row;
	}


	public function getTotalReviewsByCatId($forum_id) {
		$query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "forum_review  WHERE text_id = '" . (int)$forum_id . "'");

		return $query->row['total'];
	}
	
	public function getTotalReviews($forum_id) {
	    $query = $this->db->query("SELECT DISTINCT forum_id FROM " . DB_PREFIX . "forum  WHERE parent_id = '" . (int)$forum_id . "'");
                    $wws = $query->rows;
                    $ww = 0;
                    foreach ($wws as $we) {
                       $query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "forum_review  WHERE text_id = '" . (int)$we['forum_id'] . "'");

	                   $rr = $query->row['total']; 
	                   $ww = $ww + $rr;
                    }

		return $ww;
	}
	
    public function getReviewsByCatId($forum_id, $start = 0, $limit = 20) {
		if ($start < 0) {
			$start = 0;
		}

		if ($limit < 1) {
			$limit = 20;
		}

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "forum_review  WHERE text_id = '" . (int)$forum_id . "' ORDER BY date_added DESC LIMIT " . (int)$start . "," . (int)$limit);

		return $query->rows;
	}
	
    public function getUser($customer_id) {

			$customer_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "customer WHERE customer_id = '" . (int)$customer_id . "' AND status = '1'");

			if ($customer_query->num_rows) {
			
			$datas[] = array(
				
				'firstname'        => $customer_query->row['firstname'],
				'lastname'         => $customer_query->row['lastname'],
				'image'             => NULL,
				'email'              => $customer_query->row['email'],
                                'avatar'              => $customer_query->row['avatar'],
                                'rep'              => $customer_query->row['rep'],
				'telephone'        => $customer_query->row['telephone']
				
				);
			return $datas;
                                                                         } else {
			return false;
		}   
                                    

    }

    public function getRep($data) {

			$customer_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "forum_rep WHERE user_id = '" . (int)$data['user_id'] . "', text_id = '" . (int)$data['text_id'] . "', for_id = '" . (int)$data['for_id'] . "'");

			if ($customer_query->num_rows) {
			
			$datas[] = array(
				
				'user_id_ot'        => $customer_query->row['user_id_ot'],
				'nomer'         => $customer_query->row['nomer'],
				'text'              => $customer_query->row['text'],
                                'date_added'              => $customer_query->row['date_added']
				
				);
			return $datas;
                                                                         } else {
			return false;
		}   
                                    

    }
    
    public function addRep($data) {

		$this->db->query("INSERT INTO " . DB_PREFIX . "forum_rep SET user_id = '" . (int)$data['user_id'] . "', user_id_ot = '" . (int)$data['user_id_ot'] . "', text = '" . $this->db->escape($data['text']) . "', nomer = '" . (int)$data['nomer'] . "', for_id = '" . (int)$data['for_id'] . "', text_id = '" . (int)$data['text_id'] . "', date_added = NOW()");
    }


    public function getFormes($forum_id) {
        $query = $this->db->query("SELECT DISTINCT forum_id FROM " . DB_PREFIX . "forum  WHERE parent_id = '" . (int)$forum_id . "'");
        $wws = $query->rows;
        if ($query->num_rows) {  
            $nn = 1;
            $nm = $query->num_rows;
        //$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "forum_review  WHERE text_id = '" . (int)$forum_id . "' ORDER BY date_added DESC LIMIT 1");
            $sql = "SELECT * FROM " . DB_PREFIX . "forum_review  WHERE ";
                 
                        foreach ($wws as $we) {
                               $sql .= " text_id = '" . (int)$we['forum_id'] . "'";
                               if ($nn != $nm) {$sql .= " OR ";}
                               $nn++;
                         }
                  $sql .= " ORDER BY date_added DESC LIMIT 1";
        } else {
          return false;  
        }   
            $pro_query = $this->db->query($sql);
		if ($pro_query->rows) {
               return $pro_query->rows;
        } else {
               return false;
        }
    }

    public function getTotalReviewsByUser($customer_id) {
		$query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "forum_review  WHERE customer_id = '" . (int)$customer_id . "'");

		return $query->row['total'];
	}

    public function getData($user_id, $user_id_ot) {

        $query = $this->db->query("SELECT date_added FROM " . DB_PREFIX . "forum_rep WHERE user_id='" . (int)$user_id . "' AND user_id_ot='" . (int)$user_id_ot . "' ORDER BY date_added DESC LIMIT 1 ");
        if(isset($query->row['date_added'])) {
              $dat1 = $query->row['date_added'];
              $dat2 = date("Y-m-d H:i:s");
              $datetime1 = date_create($dat1);
              $datetime2 = date_create($dat2);
              $interval = date_diff($datetime1, $datetime2);
              return $interval->format('%d');
        } else { 
              return 10;
        }
    }

    public function getMod($limit) {
         $query = $this->db->query("SELECT * FROM " . DB_PREFIX . "forum_review ORDER BY date_added DESC LIMIT " . (int)$limit);

		return $query->rows;
    }

    public function avatar($data) {

       $this->db->query("UPDATE " . DB_PREFIX . "customer SET  avatar = '" . $this->db->escape($data['avatar']) . "' WHERE customer_id = '" . (int)$this->customer->getId() . "'");      	

    }

    public function addForum($data) {
		
		$this->db->query("INSERT INTO " . DB_PREFIX . "forum SET parent_id = '" . (int)$data['parent_id'] . "', `top` = '" . (isset($data['top']) ? (int)$data['top'] : 2) . "', `column` = 1, sort_order = 0, status = 1, customer_id = '" . (int)$this->customer->getId() . "', date_modified = NOW(), date_added = NOW()");

		$forum_id = $this->db->getLastId();

		foreach ($data['forum_description'] as $language_id => $value) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "forum_description SET forum_id = '" . (int)$forum_id . "', language_id = '" . (int)$language_id . "', name = '" . $this->db->escape($value['name']) . "', description = '" . $this->db->escape($value['description']) . "', meta_title = '" . $this->db->escape($value['name']) . "', meta_h1 = '', meta_description = '', meta_keyword = ''");
		}
		// MySQL Hierarchical Data Closure Table Pattern
		$level = 0;

		$query = $this->db->query("SELECT * FROM `" . DB_PREFIX . "forum_path` WHERE forum_id = '" . (int)$data['parent_id'] . "' ORDER BY `level` ASC");

		foreach ($query->rows as $result) {
			$this->db->query("INSERT INTO `" . DB_PREFIX . "forum_path` SET `forum_id` = '" . (int)$forum_id . "', `path_id` = '" . (int)$result['path_id'] . "', `level` = '" . (int)$level . "'");

			$level++;
		}

		$this->db->query("INSERT INTO `" . DB_PREFIX . "forum_path` SET `forum_id` = '" . (int)$forum_id . "', `path_id` = '" . (int)$forum_id . "', `level` = '" . (int)$level . "'");

		return $forum_id;
	}
	
	 public function getSet() {
         $query = $this->db->query("SELECT * FROM " . DB_PREFIX . "forum_set");

			return $query->row; 
      }

}